<template>
  <div class="dialog" v-if="visible">
    <div class="dialog-mask"></div>

    <div class="dialog-content" :style="getDialogContentStyle()">
      <div class="dialog-header" v-if="title">{{ title }}</div>
      <hr v-if="isBorderLine" />
      <div class="dialog-body">
        <slot></slot>
      </div>
      <div class="dialog-footer">
        <div @click="handleOk" class="confirm">
          <div class="content">
            {{ confirmContent }}
          </div>
        </div>
        <div @click="handleCancel" class="cancel">
          <div class="content">
            {{ cancelContent }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "MusicDialog",
  props: {
    title: {
      type: String,
      default: "",
    }, // dialog标题
    visible: {
      type: Boolean,
      default: false,
    }, // dialog显示或隐藏
    isBorderLine: {
      type: Boolean,
      default: false,
    }, // 是否需要分隔线
    confirmContent: {
      type: String,
      default: "确定",
    }, // 确认div中的内容
    cancelContent: {
      type: String,
      default: "取消",
    }, // 取消div中的内容
    width: {
      type: String,
      default: "",
    }, // dialog整体宽度
  },
  methods: {
    handleCancel() {
      this.$emit("handleCancel");
    },
    handleOk() {
      this.$emit("handleOk");
    },
    getDialogContentStyle() {
      return this.width
        ? {
            width: this.width,
          }
        : "";
    },
  },
  computed: {},
};
</script>

<style scoped lang="scss">
.dialog {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 9999;
  display: flex;
  justify-content: center;
  align-items: center;
}

.dialog-mask {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.5);
}

.dialog-content {
  min-width: 400px;
  min-height: 310px;
  background-color: #fff;
  border-radius: 4px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.2);
  z-index: 10;
  position: relative;
  font-size: 29px;
  font-weight: 500;
  color: #050505;
  line-height: 30px;
  letter-spacing: 2px;
  display: flex;
  flex-direction: column;

  .dialog-header {
    padding: 16px;
    font-size: 18px;
    font-weight: bold;
  }

  .dialog-body {
    height: 333px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;

    bottom: 78px;
  }

  .dialog-footer {
    display: flex;
    min-height: 78px;
    font-size: 29px;
    white-space: nowrap;
    bottom: 0;
    left: 0;
    right: 0;

    .confirm {
      width: 50%;
      height: 100%;
      border-top: 1px solid #d8d8d8;
      color: #050505;
      background-color: #ffffff;
      display: flex;
      justify-content: center;
      align-content: center;
      box-sizing: border-box;
      //line-height: 78px;

      .content {
        height: auto;
        padding: 29px 49px;
      }
    }

    .cancel {
      width: 50%;
      background: #001df5;
      color: #ffffff;
      border: none;
      display: flex;
      justify-content: center;
      align-content: center;
      box-sizing: border-box;
      //line-height: 78px;

      .content {
        height: auto;
        padding: 29px 49px;
      }
    }
  }
}
</style>
